#ifndef GNUBOXGLOBALS_H
#define GNUBOXGLOBALS_H

/*
  This file holds those global constants that semantically
  influence the operation of GnuBox.  Theoretically modifying this file
  should be enough to port gnubox to a new UIQ phone.
*/

#include <e32std.h>
#include <gdi.h>

#ifdef __WINS__
_LIT(KISPName, "NT RAS with stored password");
_LIT(KModemName, "Null Modem 115200bps");
#define MODEM_TABLE MODEM
#define BTREGISTERAO
#else
#ifdef __S60V2__
_LIT(KISPName, "Bt");
_LIT(KModemName, "CSD Modem");
#define MODEM_TABLE MODEM_BEARER
#define BTREGISTERAO
#else
//this is for UIQ
_LIT(KISPName, "Bt");
_LIT(KModemName, "Null Modem 115200bps");
#define MODEM_TABLE MODEM

#  endif
#endif


//these are settings for sonyericsson phones series P800 and P900
/*_LIT(KIrCOMMPort,"IrCOMM::0");
_LIT(KIrCOMMCSY,"IrCOMM");
_LIT(KIrCOMMTSY,"ERIGSM");
_LIT(KBTCOMMPort,"BTCOMM::5");
_LIT(KBTCOMMCSY,"BTDUN");
_LIT(KBTCOMMTSY,"ERIGSM");
_LIT(KDataportPort,"MUXCOMM::0");
_LIT(KDataportCSY,"ECMUX");
_LIT(KDataportTSY,"ERIGSM");*/

_LIT(KDirectTelNum,""); //this is used as TelNUm for direct 2box -> *

/*_LIT(KDirect2BoxTxt,"Direct 2box"); //ISP description
_LIT(KDialup2BoxTxt,"Dialup 2box"); //ISP description
_LIT(K1BoxTxt,"1box");//ISP description*/

// Globals
/*_LIT(KDirectOverIRTxt,     "Direct over IR        ");
_LIT(KDirectOverBTSerTxt,  "Direct over BT/serial ");
_LIT(KDirectOverBTLANTxt,  "Direct over BT/LANAcc ");
_LIT(KDirectOverBTDUNTxt,  "Direct over BT/Dialup ");
_LIT(KDirectOverBTMRTxt,   "Direct over BT/Auto   ");
_LIT(KDirectOverCableTxt,  "Direct over Cable     ");
_LIT(KPPPoverCSDGPRSTxt,   "PPP over CSD/GPRS     ");
*/
class PhoneCfg {
 public:
  struct TCfgEntry {
    TInt iID;  //the gnubox command id to define. 0 for the last entry. TGnuboxCommandIds
    const TText*  iDispName;   //this will be displayed in the first row of the display
    const TText*  iDescr;      //DIAL_OUT_ISP -> Description
    TBool     iEmptyTelNo; //true if empty tel.no is required   
    const TText*  iPortName;   //MODEM -> PortName
    const TText*  iCSY;        //MODEM -> CsyName
    const TText*  iTSY;        //MODEM -> TsyName
    TBool     iSetBT;      //true if BT discovery is required
    TUint32   iBTProfile;  //UUID of BT profile to use
    TUint32 iColor;       //background color
  };

  static const TCfgEntry PHONE_SETTINGS[]; //the first is the default => should be CSD_GPRS

  // returns NULL if there is no settings for the specified command id
  static const TCfgEntry * GetSettings(TInt aID);

  // returns default setting if there is no settings for the specified command id
  static const TCfgEntry * GetSettingsWFallback(TInt aID);

  // returns the first settings as the default
  static const TCfgEntry * GetDefaultSettings();

};

typedef PhoneCfg::TCfgEntry TCfgEntry;

// thi si the default selection id; if the current mode is this, then the current values (telno, etc. willl be saved into gnuboxDocument
#define CFGID_SAVE  EGnuboxCmdAppCSD_GPRS

#endif
